'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var isEmptyObject = function isEmptyObject() {
  var obj = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  return !Object.keys(obj).length;
};

exports['default'] = function (_ref) {
  var Plugin = _ref.Plugin;
  var t = _ref.types;

  return new Plugin("provide-modules", {
    visitor: {
      Program: {
        exit: function exit(node, parent, scope, file) {
          if (!file.opts || isEmptyObject(file.opts.extra) || isEmptyObject(file.opts.extra['provide-modules'])) {
            return;
          }
          var modulesObject = file.opts.extra['provide-modules'];

          Object.keys(modulesObject).forEach(function (binding) {
            var module = modulesObject[binding];
            if (!scope.hasBinding(binding)) {
              node.body.unshift(t.importDeclaration([t.importDefaultSpecifier(t.identifier(binding))], t.literal(module)));
            }
          });
        }
      }
    }
  });
};

module.exports = exports['default'];